unit taskdialog0;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls;

type
  TTaskDialog = class(TForm)
    ProgressBar1: TProgressBar;
    AbortBT: TButton;
    CloseBT: TButton;
    MethodLogLB: TListBox;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure AbortBTClick(Sender: TObject);
    procedure CloseBTClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private 錾 }
    running : Boolean;
  protected
    terminate : Boolean;
    procedure yield ;
    function execute : boolean ; virtual; abstract;
    procedure updatepersent( percent : integer ); overload;
    procedure updatepersent( percent : extended ); overload;
    procedure verbose( str : string );
    procedure shortmessage( str : string );
    function localgetfilesize( fname : string ) : integer;
  public
    function invoke : boolean;
    { Public 錾 }
  end;


implementation

{$R *.dfm}

function TTaskDialog.localGetfileSize(Fname:string):integer;
 var sr:tsearchrec;
    handle:cardinal;
begin
    handle := sysutils.findfirst(Fname,faanyfile,sr);
 if handle =0 then
 begin
  result := sr.Size;
 end else result:=0;
 sysutils.findclose(sr);
 localgetfilesize := result;
end;

procedure TTaskDialog.updatepersent( percent : integer );
begin
    ProgressBar1.Position := percent;
    Application.ProcessMessages;
end;

procedure TTaskDialog.updatepersent( percent : extended );
begin
    ProgressBar1.Position := Trunc(percent * 100);
    Application.ProcessMessages;
end;

procedure TTaskDialog.yield;
begin
    Application.ProcessMessages;
end;

procedure TTaskDialog.verbose( str : string );
begin
    methodloglb.items.Add( str );
    methodloglb.ItemIndex := methodloglb.Items.Count-1;
    Application.ProcessMessages;
end;

procedure TTaskDialog.shortmessage( str : string );
begin
  // methodlogsRe.Lines.Strings[ methodlogsre.Lines.count-1 ] := str;
    Application.ProcessMessages;
end;

procedure TTaskDialog.FormCreate(Sender: TObject);
begin
    running := false;
    terminate := false;
    AbortBT.Enabled := true;
end;

procedure TTaskDialog.AbortBTClick(Sender: TObject);
begin
    if Application.MessageBox( 'f܂H', 'f܂H', MB_YESNO ) = IDYES
    then
        terminate := true;
end;

function TTaskDialog.invoke : boolean;
    var status : boolean;
    abortingmessage : string;
begin
    status := false;
    abortingmessage := 'f܂';
    if( not running ) then
    begin
        running := true;
        AbortBT.Enabled := true;
        try
          status := execute;
        except on error: exception
           do begin
                status := false;
                abortingmessage := error.Message;
           end
       /// finally
        end;
        running := false;
        AbortBT.Enabled := false;
    end;
    if not status then begin
      // self.updatepersent( 0 );
      Application.MessageBox( pchar(abortingmessage), '', MB_OK );
    end;
    invoke := status;
    CloseBT.Enabled := true;
    AbortBT.Enabled := false;
    Caption := 'I';
    FormStyle := fsNormal;
end;


procedure TTaskDialog.CloseBTClick(Sender: TObject);
begin
    close;
end;

procedure TTaskDialog.Button1Click(Sender: TObject);
 var sd : tsavedialog;
begin
        sd := tsavedialog.Create(self);
        if sd.Execute then MethodLogLB.Items.SaveToFile( sd.FileName );
        sd.Free;
end;

end.




