#!perl
#
use strict;
no strict "refs";
use Getopt::Long;
use Fcntl;
use Fcntl 'SEEK_CUR';
#
my (%opt)=(
	);
GetOptions(
	"extension" => sub { $opt{"extension"}=1; },
	);
#
foreach my $file (@ARGV){
	slicezip( $file, %opt );
}
#
sub firstpath($%){
	my($path0, %opt )= @_;
	my(@path)=split("/", $path0 );
	my(@part)= $#path > 1 ? $path[$#path-1] : "_" ;
	if( $opt{"extension"} ){
		$path0 =~ /\.(\w+)$/;
		push @part, $1;
	}
	return join " ", map { "[$_]" } @part;
}
#
# http://www.hummel1.de/prog/zipview/zipstruc.htm
#
sub slicezip($%){
	my ($sourcefilename, %opt)=@_;
	my (%part) = ();
	my (%offsetmap) = ();
	print STDERR "$sourcefilename\n";
	
	open( ZIP, $sourcefilename ) || die;
	binmode(ZIP);
	
	my $header1;
	while( sysread( ZIP, $header1, 4 ) ){
		die if $header1 !~ /^PK/ ;
		my($key, $type0) = unpack( "a2n1",  $header1 );
		my $type = sprintf "%04x", $type0;
		##print "$key, $type\n" ;
		my $length = 0;
		my $headxx = undef;
		my $filename = undef;
		if( $type0 == 0x304 ){
			sysread( ZIP, $headxx, 26 );
			my (@datas)= unpack( "s3i4s2", $headxx );
			my $xsize = $datas[5];
			my $fnsize = $datas[7];
			my $extsize = $datas[8];
			### my($xsize,$fnsize,$extsize)= unpack( "x2x2x2x4x4i1x4s1s1", $headxx );
			sysread( ZIP, $filename, $fnsize );
			print "PK34 $filename $xsize+$extsize ( @{datas} )\n";
			$length += $extsize + $xsize;
		} elsif( $type0 == 0x102 ){
			#last;
			sysread( ZIP, $headxx, 42 );
			my(@datas) = unpack( "s4i4s5i2", $headxx );
			my $xsize = $datas[6];
			my $fnsize = $datas[8];
			my $extsize = $datas[9];
			### my($xsize,$fnsize,$extsize)= unpack( "x2x2x2x2x4x4i1x4s1s1s1x2x2x4x4", $headxx );
			sysread( ZIP, $filename, $fnsize );
		
			##my $datas = join ",", @datas;
			print ">PK12 $filename $xsize+$extsize +$datas[14]\n";
			$datas[14] = $offsetmap{$filename};
			$headxx = pack( "s4i4s5i2", @datas );
			print "<PK12 $filename $xsize+$extsize +$datas[14] ( @{datas} ) \n";
			##last;
			$length += $extsize;
		} elsif( $type0 == 0x506 ){
			##last;
			sysread( ZIP, $headxx, 22 );
			my(@foo)= unpack( "s4i2s1", $headxx );
			print "<PK56 ".join("/",@foo)."\n";
			last;
		} else {
			die $type0;
		}
		my $part = firstpath( $filename, %opt );
		$part =~ s/[\.\/]/ /g;
		if( ! defined $part{$part} ){
			my $partname = "$sourcefilename $part.zip";
			$partname =~ s/\.zip / /g;
			open( $part, ">$partname" ) || die;
			binmode( $part );
			$part{$part} = [ 0, 0, 0, ];
		}
		##sysseek( ZIP, $length, SEEK_CUR ) if $length;
		##print length($headxx);

		syswrite( $part, $header1 ) || die;
		syswrite( $part, $headxx ) || die;
		syswrite( $part, $filename );
		if( $length ) {
			sysread( ZIP, my $buffer, $length ) || die;
			syswrite( $part, $buffer, $length ) || die;
		}
		if( $type0 == 0x304 ){
			$offsetmap{$filename} = $part{$part}->[1];

			$part{$part}->[0]++;
			$part{$part}->[1] += length($header1)+length($headxx)+length($filename)+$length;
			##$part{$part}->[2] += length($header1)+length($headxx)+length($filename);
		} elsif( $type0 == 0x102 ){
			$part{$part}->[2] += length($header1)+length($headxx)+length($filename)+$length;
		}
		##last;
	}
	while( my($handle,$sizes)=each %part ){
		my $buffer = pack( "s4i2s1", 
			0, 0,  $sizes->[0], $sizes->[0], $sizes->[2], $sizes->[1], 0, 0 );
		syswrite( $handle, "PK\5\6${buffer}" ) || die;
		my(@foo)= unpack( "s4i2s1", $buffer );
		print ">PK56 ".join("/",@foo)."\n";
		close $handle || die;
	}
	close ZIP;
}
#
