#!perl
#
use strict;
no strict "refs";
use Getopt::Long;
use Fcntl;
use Fcntl 'SEEK_CUR';
#
foreach my $file (@ARGV){
	slicezip( $file, () );
}
#
# http://www.hummel1.de/prog/zipview/zipstruc.htm
#
sub slicezip($%){
	my ($sourcefilename, %opt)=@_;
	my (%part) = ();
	my $datasize = 0;
	my $pk12size = 0;
	my %offsetmap = ();
	my $filecount = 0;
	print STDERR "$sourcefilename\n";
	
	open( ZIP, $sourcefilename ) || die "not found \"$sourcefilename\"";
	binmode(ZIP);
	
	my $header1;
	while( sysread( ZIP, $header1, 4 ) ){
		die "$header1" if $header1 !~ /^PK/ ;
		my($key, $type0) = unpack( "a2n1",  $header1 );
		my $type = sprintf "%04x", $type0;
		##print "$key, $type\n" ;
		my $length = 0;
		my $headxx = undef;
		my $filename = undef;
		if( $type0 == 0x304 ){
			sysread( ZIP, $headxx, 26 );
			my (@datas)= unpack( "s3i4s2", $headxx );
			my $xsize = $datas[5];
			my $fnsize = $datas[7];
			my $extsize = $datas[8];
			### my($xsize,$fnsize,$extsize)= unpack( "x2x2x2x4x4i1x4s1s1", $headxx );
			sysread( ZIP, $filename, $fnsize );
			print "PK34 $filename $xsize+$extsize ( @{datas} )\n";
			$length += $extsize + $xsize;
		} elsif( $type0 == 0x102 ){
			#last;
			sysread( ZIP, $headxx, 42 );
			my(@datas) = unpack( "s4i4s5i2", $headxx );
			my $xsize = $datas[6];
			my $fnsize = $datas[8];
			my $extsize = $datas[9];
			### my($xsize,$fnsize,$extsize)= unpack( "x2x2x2x2x4x4i1x4s1s1s1x2x2x4x4", $headxx );
			sysread( ZIP, $filename, $fnsize );
		
			##my $datas = join ",", @datas;
			print ">PK12 $filename $xsize+$extsize +$datas[14]\n";
			die "PK12 offset differ \"$filename\"" unless $datas[14] == $offsetmap{$filename};
			##last;
			$length += $extsize;
		} elsif( $type0 == 0x506 ){
			##last;
			sysread( ZIP, $headxx, 22 );
			my(@foo)= unpack( "s4i2s1", $headxx );
			print "<PK56 ".join("/",@foo)."\n";
			die "PK56 totalent $foo[2] != $filecount" unless $foo[2] == $filecount;
			die "PK56 filecount $foo[3] != $filecount" unless $foo[3] == $filecount;
			die "PK56 pk12size $foo[4] != $pk12size" unless $foo[4] == $pk12size;
			die "PK56 datasize $foo[5] != $datasize" unless $foo[5] == $datasize;

			last;
		} else {
			die "unknown pktype \"$type0\"";
		}
		if( $length ) {
			sysread( ZIP, my $buffer, $length ) || die;
		}
		if( $type0 == 0x304 ){
			$offsetmap{$filename} = $datasize;

			$filecount++;
			$datasize += length($header1)+length($headxx)+length($filename)+$length;
			##$part{$part}->[2] += length($header1)+length($headxx)+length($filename);
		} elsif( $type0 == 0x102 ){
			$pk12size += length($header1)+length($headxx)+length($filename)+$length;
			print "pk12size=$pk12size\n";
		}
		##last;
	}
	close ZIP;
}
#
