unit tinyhash;

interface

uses
    classes,sysutils;

type
    THash = class(TStringList)
    private
        function getasobject( index : string ) : TObject;
        function getasinteger( index : string ) : integer;
        function getbylongword( index : longword ) : tobject;
        function hex( value : longword ) : string;
    public
      //  procedure add( name : string ; value : TObject );
        procedure addInt( name : string ; value : integer );
        procedure addbylongword( index : longword ; value : tobject );
        function exists( name : string ) : boolean; overload;
        function exists( name : longword ) : boolean; overload;
        property asObject[ index : string ] : TObject read getasobject;
        property asInteger[ index : string ] : integer read getasinteger;
        property bylongword[ index : longword ] : tobject read getbylongword;
        function indexof( name : longword ): integer; overload; 
    end;

implementation

function thash.hex( value : longword ) : string;
begin
    result := format( '%08x', [value ] );
end;

function thash.exists( name : string ) : boolean;
begin
    result := inherited indexof(name) >= 0;
end;

function thash.exists( name : longword ) : boolean;
begin
    result := self.indexof( name ) >= 0;
end;

function thash.indexof( name : longword ) : integer;
begin
    result := inherited indexof( hex(name) );
end;

procedure thash.addbylongword( index : longword ; value : tobject );
begin
  inherited addobject( format( '%08x', [ index ] ), value );
end;

function thash.getbylongword( index : longword ) : tobject;
begin
  result := Objects[ indexof( index ) ];
end;

procedure thash.addInt( name : string ; value : integer );
begin
    inherited AddObject( name, TObject(value) );
end;

function thash.getasobject( index : string ) : TObject;
 var iiindex : integer;
begin
    iiindex := indexof(index);
    result := nil;
    if iiindex >= 0 then result := Objects[ iiindex ];
end;

function thash.getasinteger( index : string ) : integer;
 var iiindex : integer;
begin
    iiindex := indexof(index);
    getasinteger := 0;
    if iiindex >= 0 then result := integer( Objects[ iiindex ] );
end;

end.
